# medium_search

Unofficial search provider for [Medium](https://medium.com).

This library provides you an easy way to get search results from [Medium](https://medium.com) website.

It supports searching for:

- posts
- tags
- users
- publications

___

## Insalling

- add to your `pubspec.yaml`:

```yaml
medium_search: ^0.0.1
```

- get it

`dart pub get`


- import it

```dart
import 'package:medium_search/medium_search.dart';
```

- initialize

```dart
var medium = Medium();
```



## get tags:

```dart
var tags = await medium.getTags("Hello");

for (var tag in tags) {
    print("The tag `${tag.name}` has ${tag.postCount} posts.");
}
```


## get posts:

```dart
var page = await medium.getPosts("hello");

for (var post in page.posts) {
    print("${post.title} => ${post.id}");
}
```

and you can get the next page by:

```dart
var nextPage = await page.nextPage();
```

or by getting specific page number:

```dart
var page = await medium.getPosts("Hello", page: 3); // which returns the 3th page for the query 'Hello'.
```


## get users:

```dart
var page = await medium.getUsers("ronaldo");

for (var user in page.users) {
    print("${user.name} => ${user.bio}");
}
```


## get publications:

```dart
var page = await medium.getPublications("Hello");

for (var public in page.users) {
    print("${public.name} => ${public.description}");
}
```