import 'package:json_annotation/json_annotation.dart';

part 'posts_search_dto.g.dart';

@JsonSerializable()
class PostsSearchDto {
  PostsSearchDto({
    this.success,
    this.payload,
    this.v,
    this.b,
  });

  bool? success;
  Payload? payload;
  int? v;
  String? b;

  factory PostsSearchDto.fromJson(Map<String, dynamic> json) =>
      _$PostsSearchDtoFromJson(json);
  Map<String, dynamic> toJson() => _$PostsSearchDtoToJson(this);
}

@JsonSerializable()
class Payload {
  Payload({
    this.posts,
    this.references,
    this.paging,
  });

  @JsonKey(name: "value")
  List<Value>? posts;

  References? references;
  Paging? paging;

  factory Payload.fromJson(Map<String, dynamic> json) =>
      _$PayloadFromJson(json);
  Map<String, dynamic> toJson() => _$PayloadToJson(this);
}

@JsonSerializable()
class Paging {
  Paging({
    this.path,
    this.next,
    this.method,
  });

  String? path;
  Next? next;
  String? method;

  factory Paging.fromJson(Map<String, dynamic> json) => _$PagingFromJson(json);
  Map<String, dynamic> toJson() => _$PagingToJson(this);
}

@JsonSerializable()
class Next {
  Next({
    this.ignoredIds,
    this.page,
    this.pageSize,
  });

  List<String>? ignoredIds;
  int? page;
  int? pageSize;

  factory Next.fromJson(Map<String, dynamic> json) => _$NextFromJson(json);
  Map<String, dynamic> toJson() => _$NextToJson(this);
}

@JsonSerializable()
class References {
  References({
    this.user,
    this.collection,
  });

  Map<String, User>? user;
  Collection? collection;

  factory References.fromJson(Map<String, dynamic> json) =>
      _$ReferencesFromJson(json);
  Map<String, dynamic> toJson() => _$ReferencesToJson(this);
}

@JsonSerializable()
class Collection {
  Collection({
    this.the7F60Cf5620C9,
  });

  The7F60Cf5620C9? the7F60Cf5620C9;

  factory Collection.fromJson(Map<String, dynamic> json) =>
      _$CollectionFromJson(json);
  Map<String, dynamic> toJson() => _$CollectionToJson(this);
}

// TODO
@JsonSerializable()
class The7F60Cf5620C9 {
  The7F60Cf5620C9({
    this.id,
    this.name,
    this.slug,
    this.tags,
    this.creatorId,
    this.description,
    this.shortDescription,
    this.image,
    this.metadata,
    this.virtuals,
    this.logo,
    this.twitterUsername,
    this.facebookPageName,
    this.collectionMastheadId,
    this.domain,
    this.tintColor,
    this.lightText,
    this.favicon,
    this.colorPalette,
    this.navItems,
    this.colorBehavior,
    this.acceleratedMobilePagesState,
    this.collectionFeatures,
    this.ampLogo,
    this.header,
    this.paidForDomainAt,
    this.subscriberCount,
    this.tagline,
    this.instagramUsername,
    this.isOptedIntoAurora,
    this.newsletterV3,
    this.isCurationAllowedByDefault,
    this.polarisCoverImage,
    this.ptsQualifiedAt,
    this.type,
  });

  String? id;
  String? name;
  String? slug;
  List<String>? tags;
  String? creatorId;
  String? description;
  String? shortDescription;
  PreviewImage? image;
  The7F60Cf5620C9Metadata? metadata;
  The7F60Cf5620C9Virtuals? virtuals;
  PreviewImage? logo;
  String? twitterUsername;
  String? facebookPageName;
  String? collectionMastheadId;
  String? domain;
  String? tintColor;
  bool? lightText;
  PreviewImage? favicon;
  ColorPalette? colorPalette;
  List<NavItem>? navItems;
  int? colorBehavior;
  int? acceleratedMobilePagesState;
  List<int>? collectionFeatures;
  PreviewImage? ampLogo;
  Header? header;
  int? paidForDomainAt;
  int? subscriberCount;
  String? tagline;
  String? instagramUsername;
  bool? isOptedIntoAurora;
  NewsletterV3? newsletterV3;
  bool? isCurationAllowedByDefault;
  PreviewImage? polarisCoverImage;
  int? ptsQualifiedAt;
  String? type;

  factory The7F60Cf5620C9.fromJson(Map<String, dynamic> json) =>
      _$The7F60Cf5620C9FromJson(json);
  Map<String, dynamic> toJson() => _$The7F60Cf5620C9ToJson(this);
}

@JsonSerializable()
class PreviewImage {
  PreviewImage({
    this.imageId,
    this.filter,
    this.backgroundSize,
    this.originalWidth,
    this.originalHeight,
    this.strategy,
    this.height,
    this.width,
  });

  String? imageId;
  String? filter;
  String? backgroundSize;
  int? originalWidth;
  int? originalHeight;
  String? strategy;
  int? height;
  int? width;

  factory PreviewImage.fromJson(Map<String, dynamic> json) =>
      _$PreviewImageFromJson(json);
  Map<String, dynamic> toJson() => _$PreviewImageToJson(this);
}

@JsonSerializable()
class ColorPalette {
  ColorPalette({
    this.defaultBackgroundSpectrum,
    this.tintBackgroundSpectrum,
    this.highlightSpectrum,
    this.darkBackgroundSpectrum,
  });

  Spectrum? defaultBackgroundSpectrum;
  Spectrum? tintBackgroundSpectrum;
  Spectrum? highlightSpectrum;
  Spectrum? darkBackgroundSpectrum;

  factory ColorPalette.fromJson(Map<String, dynamic> json) =>
      _$ColorPaletteFromJson(json);
  Map<String, dynamic> toJson() => _$ColorPaletteToJson(this);
}

@JsonSerializable()
class Spectrum {
  Spectrum({
    this.colorPoints,
    this.backgroundColor,
  });

  List<ColorPoint>? colorPoints;
  String? backgroundColor;

  factory Spectrum.fromJson(Map<String, dynamic> json) =>
      _$SpectrumFromJson(json);
  Map<String, dynamic> toJson() => _$SpectrumToJson(this);
}

@JsonSerializable()
class ColorPoint {
  ColorPoint({
    this.color,
    this.point,
  });

  String? color;
  double? point;

  factory ColorPoint.fromJson(Map<String, dynamic> json) =>
      _$ColorPointFromJson(json);
  Map<String, dynamic> toJson() => _$ColorPointToJson(this);
}

@JsonSerializable()
class Header {
  Header({
    this.backgroundImage,
    this.logoImage,
    this.alignment,
    this.layout,
  });

  BackgroundImage? backgroundImage;
  LogoImage? logoImage;
  int? alignment;
  int? layout;

  factory Header.fromJson(Map<String, dynamic> json) => _$HeaderFromJson(json);
  Map<String, dynamic> toJson() => _$HeaderToJson(this);
}

@JsonSerializable()
class BackgroundImage {
  BackgroundImage();

  factory BackgroundImage.fromJson(Map<String, dynamic> json) =>
      _$BackgroundImageFromJson(json);
  Map<String, dynamic> toJson() => _$BackgroundImageToJson(this);
}

@JsonSerializable()
class LogoImage {
  LogoImage({
    this.id,
    this.originalWidth,
    this.originalHeight,
    this.alt,
    this.isFeatured,
    this.unsplashPhotoId,
  });

  String? id;
  int? originalWidth;
  int? originalHeight;
  String? alt;
  bool? isFeatured;
  String? unsplashPhotoId;

  factory LogoImage.fromJson(Map<String, dynamic> json) =>
      _$LogoImageFromJson(json);
  Map<String, dynamic> toJson() => _$LogoImageToJson(this);
}

@JsonSerializable()
class The7F60Cf5620C9Metadata {
  The7F60Cf5620C9Metadata({
    this.followerCount,
    this.activeAt,
  });

  int? followerCount;
  int? activeAt;

  factory The7F60Cf5620C9Metadata.fromJson(Map<String, dynamic> json) =>
      _$The7F60Cf5620C9MetadataFromJson(json);
  Map<String, dynamic> toJson() => _$The7F60Cf5620C9MetadataToJson(this);
}

@JsonSerializable()
class NavItem {
  NavItem({
    this.type,
    this.title,
    this.url,
    this.topicId,
    this.source,
  });

  int? type;
  String? title;
  String? url;
  String? topicId;
  String? source;

  factory NavItem.fromJson(Map<String, dynamic> json) =>
      _$NavItemFromJson(json);
  Map<String, dynamic> toJson() => _$NavItemToJson(this);
}

@JsonSerializable()
class NewsletterV3 {
  NewsletterV3({
    this.newsletterV3Id,
    this.type,
    this.name,
    this.description,
    this.collectionId,
    this.newsletterSlug,
    this.isSubscribed,
    this.showPromo,
    this.avatarImageId,
    this.creatorId,
    this.showNewsletterPostsInCollectionHome,
    this.exportableSubscribersCount,
    this.subscribersCount,
    this.promoHeadline,
    this.promoBody,
    this.replyToEmail,
  });

  String? newsletterV3Id;
  int? type;
  String? name;
  String? description;
  String? collectionId;
  String? newsletterSlug;
  bool? isSubscribed;
  bool? showPromo;
  String? avatarImageId;
  String? creatorId;
  bool? showNewsletterPostsInCollectionHome;
  int? exportableSubscribersCount;
  int? subscribersCount;
  String? promoHeadline;
  String? promoBody;
  String? replyToEmail;

  factory NewsletterV3.fromJson(Map<String, dynamic> json) =>
      _$NewsletterV3FromJson(json);
  Map<String, dynamic> toJson() => _$NewsletterV3ToJson(this);
}

@JsonSerializable()
class The7F60Cf5620C9Virtuals {
  The7F60Cf5620C9Virtuals({
    this.permissions,
    this.isSubscribed,
    this.isEnrolledInHightower,
    this.isEligibleForHightower,
    this.isSubscribedToCollectionEmails,
    this.isMuted,
    this.canToggleEmail,
    this.isWriter,
  });

  Map<String, bool>? permissions;
  bool? isSubscribed;
  bool? isEnrolledInHightower;
  bool? isEligibleForHightower;
  bool? isSubscribedToCollectionEmails;
  bool? isMuted;
  bool? canToggleEmail;
  bool? isWriter;

  factory The7F60Cf5620C9Virtuals.fromJson(Map<String, dynamic> json) =>
      _$The7F60Cf5620C9VirtualsFromJson(json);
  Map<String, dynamic> toJson() => _$The7F60Cf5620C9VirtualsToJson(this);
}

@JsonSerializable()
class User {
  User({
    this.userId,
    this.name,
    this.username,
    this.createdAt,
    this.imageId,
    this.backgroundImageId,
    this.bio,
    this.twitterScreenName,
    this.allowNotes,
    this.mediumMemberAt,
    this.isWriterProgramEnrolled,
    this.isSuspended,
    this.isMembershipTrialEligible,
    this.optInToIceland,
    this.subdomainCreatedAt,
    this.hasCompletedProfile,
    this.userDismissableFlags,
    this.hasSeenIcelandOnboarding,
    this.postSubscribeMembershipUpsellShownAt,
    this.replyToEmailBannerShownCount,
    this.type,
    this.isCreatorPartnerProgramEnrolled,
  });

  String? userId;
  String? name;
  String? username;
  int? createdAt;
  String? imageId;
  String? backgroundImageId;
  String? bio;
  String? twitterScreenName;
  int? allowNotes;
  int? mediumMemberAt;
  bool? isWriterProgramEnrolled;
  bool? isSuspended;
  bool? isMembershipTrialEligible;
  bool? optInToIceland;
  int? subdomainCreatedAt;
  bool? hasCompletedProfile;
  List<int>? userDismissableFlags;
  bool? hasSeenIcelandOnboarding;
  int? postSubscribeMembershipUpsellShownAt;
  int? replyToEmailBannerShownCount;
  String? type;
  bool? isCreatorPartnerProgramEnrolled;

  factory User.fromJson(Map<String, dynamic> json) => _$UserFromJson(json);
  Map<String, dynamic> toJson() => _$UserToJson(this);
}

@JsonSerializable()
class Value {
  Value({
    this.id,
    this.versionId,
    this.creatorId,
    this.homeCollectionId,
    this.title,
    this.detectedLanguage,
    this.latestVersion,
    this.latestPublishedVersion,
    this.hasUnpublishedEdits,
    this.latestRev,
    this.createdAt,
    this.updatedAt,
    this.acceptedAt,
    this.firstPublishedAt,
    this.latestPublishedAt,
    this.vote,
    this.experimentalCss,
    this.displayAuthor,
    this.virtuals,
    this.coverless,
    this.slug,
    this.translationSourcePostId,
    this.translationSourceCreatorId,
    this.isApprovedTranslation,
    this.inResponseToPostId,
    this.inResponseToRemovedAt,
    this.isTitleSynthesized,
    this.allowResponses,
    this.importedUrl,
    this.importedPublishedAt,
    this.visibility,
    this.uniqueSlug,
    this.previewContent,
    this.license,
    this.inResponseToMediaResourceId,
    this.canonicalUrl,
    this.approvedHomeCollectionId,
    this.isNewsletter,
    this.newsletterId,
    this.webCanonicalUrl,
    this.mediumUrl,
    this.migrationId,
    this.notifyFollowers,
    this.notifyTwitter,
    this.notifyFacebook,
    this.responseHiddenOnParentPostAt,
    this.isSeries,
    this.isSubscriptionLocked,
    this.seriesLastAppendedAt,
    this.audioVersionDurationSec,
    this.sequenceId,
    this.isEligibleForRevenue,
    this.isBlockedFromHightower,
    this.deletedAt,
    this.lockedPostSource,
    this.hightowerMinimumGuaranteeStartsAt,
    this.hightowerMinimumGuaranteeEndsAt,
    this.featureLockRequestAcceptedAt,
    this.mongerRequestType,
    this.layerCake,
    this.socialTitle,
    this.socialDek,
    this.editorialPreviewTitle,
    this.editorialPreviewDek,
    this.curationEligibleAt,
    this.primaryTopicId,
    this.isProxyPost,
    this.proxyPostFaviconUrl,
    this.proxyPostProviderName,
    this.proxyPostType,
    this.isSuspended,
    this.isLimitedState,
    this.seoTitle,
    this.previewContent2,
    this.cardType,
    this.isDistributionAlertDismissed,
    this.isShortform,
    this.shortformType,
    this.responsesLocked,
    this.isLockedResponse,
    this.isPublishToEmail,
    this.responseDistribution,
    this.isMarkedPaywallOnly,
    this.type,
  });

  String? id;
  String? versionId;
  String? creatorId;
  String? homeCollectionId;
  String? title;
  String? detectedLanguage;
  String? latestVersion;
  String? latestPublishedVersion;
  bool? hasUnpublishedEdits;
  int? latestRev;
  int? createdAt;
  int? updatedAt;
  int? acceptedAt;
  int? firstPublishedAt;
  int? latestPublishedAt;
  bool? vote;
  String? experimentalCss;
  String? displayAuthor;
  ValueVirtuals? virtuals;
  bool? coverless;
  String? slug;
  String? translationSourcePostId;
  String? translationSourceCreatorId;
  bool? isApprovedTranslation;
  String? inResponseToPostId;
  int? inResponseToRemovedAt;
  bool? isTitleSynthesized;
  bool? allowResponses;
  String? importedUrl;
  int? importedPublishedAt;
  int? visibility;
  String? uniqueSlug;
  PreviewContent? previewContent;
  int? license;
  String? inResponseToMediaResourceId;
  String? canonicalUrl;
  String? approvedHomeCollectionId;
  bool? isNewsletter;
  String? newsletterId;
  String? webCanonicalUrl;
  String? mediumUrl;
  String? migrationId;
  bool? notifyFollowers;
  bool? notifyTwitter;
  bool? notifyFacebook;
  int? responseHiddenOnParentPostAt;
  bool? isSeries;
  bool? isSubscriptionLocked;
  int? seriesLastAppendedAt;
  int? audioVersionDurationSec;
  String? sequenceId;
  bool? isEligibleForRevenue;
  bool? isBlockedFromHightower;
  int? deletedAt;
  int? lockedPostSource;
  int? hightowerMinimumGuaranteeStartsAt;
  int? hightowerMinimumGuaranteeEndsAt;
  int? featureLockRequestAcceptedAt;
  int? mongerRequestType;
  int? layerCake;
  String? socialTitle;
  String? socialDek;
  String? editorialPreviewTitle;
  String? editorialPreviewDek;
  int? curationEligibleAt;
  String? primaryTopicId;
  bool? isProxyPost;
  String? proxyPostFaviconUrl;
  String? proxyPostProviderName;
  int? proxyPostType;
  bool? isSuspended;
  bool? isLimitedState;
  String? seoTitle;
  PreviewContent2? previewContent2;
  int? cardType;
  bool? isDistributionAlertDismissed;
  bool? isShortform;
  int? shortformType;
  bool? responsesLocked;
  bool? isLockedResponse;
  bool? isPublishToEmail;
  int? responseDistribution;
  bool? isMarkedPaywallOnly;
  String? type;

  factory Value.fromJson(Map<String, dynamic> json) => _$ValueFromJson(json);
  Map<String, dynamic> toJson() => _$ValueToJson(this);
}

@JsonSerializable()
class PreviewContent {
  PreviewContent({
    this.bodyModel,
    this.isFullContent,
    this.subtitle,
  });

  PreviewContentBodyModel? bodyModel;
  bool? isFullContent;
  String? subtitle;

  factory PreviewContent.fromJson(Map<String, dynamic> json) =>
      _$PreviewContentFromJson(json);
  Map<String, dynamic> toJson() => _$PreviewContentToJson(this);
}

@JsonSerializable()
class PreviewContentBodyModel {
  PreviewContentBodyModel({
    this.paragraphs,
    this.sections,
  });

  List<Paragraph>? paragraphs;
  List<PurpleSection>? sections;

  factory PreviewContentBodyModel.fromJson(Map<String, dynamic> json) =>
      _$PreviewContentBodyModelFromJson(json);
  Map<String, dynamic> toJson() => _$PreviewContentBodyModelToJson(this);
}

@JsonSerializable()
class Paragraph {
  Paragraph({
    this.name,
    this.type,
    this.text,
    this.layout,
    this.metadata,
    this.markups,
    this.alignment,
    this.hasDropCap,
    this.dropCapImage,
  });

  String? name;
  int? type;
  String? text;
  int? layout;
  LogoImage? metadata;
  List<Markup>? markups;
  int? alignment;
  bool? hasDropCap;
  LogoImage? dropCapImage;

  factory Paragraph.fromJson(Map<String, dynamic> json) =>
      _$ParagraphFromJson(json);
  Map<String, dynamic> toJson() => _$ParagraphToJson(this);
}

@JsonSerializable()
class Markup {
  Markup({
    this.type,
    this.start,
    this.end,
    this.href,
    this.title,
    this.rel,
    this.anchorType,
  });

  int? type;
  int? start;
  int? end;
  String? href;
  String? title;
  String? rel;
  int? anchorType;

  factory Markup.fromJson(Map<String, dynamic> json) => _$MarkupFromJson(json);
  Map<String, dynamic> toJson() => _$MarkupToJson(this);
}

@JsonSerializable()
class PurpleSection {
  PurpleSection({
    this.startIndex,
  });

  int? startIndex;

  factory PurpleSection.fromJson(Map<String, dynamic> json) =>
      _$PurpleSectionFromJson(json);
  Map<String, dynamic> toJson() => _$PurpleSectionToJson(this);
}

@JsonSerializable()
class PreviewContent2 {
  PreviewContent2({
    this.bodyModel,
    this.isFullContent,
    this.subtitle,
  });

  PreviewContent2BodyModel? bodyModel;
  bool? isFullContent;
  String? subtitle;

  factory PreviewContent2.fromJson(Map<String, dynamic> json) =>
      _$PreviewContent2FromJson(json);
  Map<String, dynamic> toJson() => _$PreviewContent2ToJson(this);
}

@JsonSerializable()
class PreviewContent2BodyModel {
  PreviewContent2BodyModel({
    this.paragraphs,
    this.sections,
  });

  List<Paragraph>? paragraphs;
  List<FluffySection>? sections;

  factory PreviewContent2BodyModel.fromJson(Map<String, dynamic> json) =>
      _$PreviewContent2BodyModelFromJson(json);
  Map<String, dynamic> toJson() => _$PreviewContent2BodyModelToJson(this);
}

@JsonSerializable()
class FluffySection {
  FluffySection({
    this.name,
    this.startIndex,
  });

  String? name;
  int? startIndex;

  factory FluffySection.fromJson(Map<String, dynamic> json) =>
      _$FluffySectionFromJson(json);
  Map<String, dynamic> toJson() => _$FluffySectionToJson(this);
}

@JsonSerializable()
class ValueVirtuals {
  ValueVirtuals({
    this.statusForCollection,
    this.allowNotes,
    this.previewImage,
    this.wordCount,
    this.imageCount,
    this.readingTime,
    this.subtitle,
    this.publishedInCount,
    this.usersBySocialRecommends,
    this.noIndex,
    this.recommends,
    this.isBookmarked,
    this.tags,
    this.socialRecommendsCount,
    this.responsesCreatedCount,
    this.links,
    this.isLockedPreviewOnly,
    this.metaDescription,
    this.totalClapCount,
    this.sectionCount,
    this.readingList,
    this.topics,
  });

  String? statusForCollection;
  bool? allowNotes;
  PreviewImage? previewImage;
  int? wordCount;
  int? imageCount;
  double? readingTime;
  String? subtitle;
  int? publishedInCount;
  List<dynamic>? usersBySocialRecommends;
  bool? noIndex;
  int? recommends;
  bool? isBookmarked;
  List<Tag>? tags;
  int? socialRecommendsCount;
  int? responsesCreatedCount;
  Links? links;
  bool? isLockedPreviewOnly;
  String? metaDescription;
  int? totalClapCount;
  int? sectionCount;
  int? readingList;
  List<Topic>? topics;

  factory ValueVirtuals.fromJson(Map<String, dynamic> json) =>
      _$ValueVirtualsFromJson(json);
  Map<String, dynamic> toJson() => _$ValueVirtualsToJson(this);
}

@JsonSerializable()
class Links {
  Links({
    this.entries,
    this.version,
    this.generatedAt,
  });

  List<Entry>? entries;
  String? version;
  int? generatedAt;

  factory Links.fromJson(Map<String, dynamic> json) => _$LinksFromJson(json);
  Map<String, dynamic> toJson() => _$LinksToJson(this);
}

@JsonSerializable()
class Entry {
  Entry({
    this.url,
    this.alts,
    this.httpStatus,
  });

  String? url;
  List<Alt>? alts;
  int? httpStatus;

  factory Entry.fromJson(Map<String, dynamic> json) => _$EntryFromJson(json);
  Map<String, dynamic> toJson() => _$EntryToJson(this);
}

@JsonSerializable()
class Alt {
  Alt({
    this.type,
    this.url,
  });

  int? type;
  String? url;

  factory Alt.fromJson(Map<String, dynamic> json) => _$AltFromJson(json);
  Map<String, dynamic> toJson() => _$AltToJson(this);
}

@JsonSerializable()
class Tag {
  Tag({
    this.slug,
    this.name,
    this.postCount,
    this.metadata,
    this.type,
  });

  String? slug;
  String? name;
  int? postCount;
  TagMetadata? metadata;
  Type? type;

  factory Tag.fromJson(Map<String, dynamic> json) => _$TagFromJson(json);
  Map<String, dynamic> toJson() => _$TagToJson(this);
}

@JsonSerializable()
class TagMetadata {
  TagMetadata({
    this.postCount,
    this.coverImage,
  });

  int? postCount;
  LogoImage? coverImage;

  factory TagMetadata.fromJson(Map<String, dynamic> json) =>
      _$TagMetadataFromJson(json);
  Map<String, dynamic> toJson() => _$TagMetadataToJson(this);
}

enum Type {
  @JsonValue("Tag")
  tag,
}

@JsonSerializable()
class Topic {
  Topic({
    this.topicId,
    this.slug,
    this.createdAt,
    this.deletedAt,
    this.image,
    this.name,
    this.description,
    this.relatedTopics,
    this.visibility,
    this.relatedTags,
    this.relatedTopicIds,
    this.seoTitle,
    this.type,
  });

  String? topicId;
  String? slug;
  int? createdAt;
  int? deletedAt;
  LogoImage? image;
  String? name;
  String? description;
  List<dynamic>? relatedTopics;
  int? visibility;
  List<dynamic>? relatedTags;
  List<dynamic>? relatedTopicIds;
  String? seoTitle;
  String? type;

  factory Topic.fromJson(Map<String, dynamic> json) => _$TopicFromJson(json);
  Map<String, dynamic> toJson() => _$TopicToJson(this);
}
