import 'package:json_annotation/json_annotation.dart';

part 'publications_search_dto.g.dart';

@JsonSerializable()
class PublicationsSearchDto {
  PublicationsSearchDto({
    this.success,
    this.payload,
    this.v,
    this.b,
  });

  bool? success;
  Payload? payload;
  int? v;
  String? b;

  factory PublicationsSearchDto.fromJson(Map<String, dynamic> json) =>
      _$PublicationsSearchDtoFromJson(json);
  Map<String, dynamic> toJson() => _$PublicationsSearchDtoToJson(this);
}

@JsonSerializable()
class Payload {
  Payload({
    this.value,
    this.total,
    this.references,
    this.paging,
  });

  List<Value>? value;
  int? total;
  References? references;
  Paging? paging;

  factory Payload.fromJson(Map<String, dynamic> json) =>
      _$PayloadFromJson(json);
  Map<String, dynamic> toJson() => _$PayloadToJson(this);
}

@JsonSerializable()
class Paging {
  Paging({
    this.path,
    this.next,
    this.method,
  });

  String? path;
  Next? next;
  String? method;

  factory Paging.fromJson(Map<String, dynamic> json) => _$PagingFromJson(json);
  Map<String, dynamic> toJson() => _$PagingToJson(this);
}

@JsonSerializable()
class Next {
  Next({
    this.ignoredIds,
    this.page,
    this.pageSize,
  });

  List<String>? ignoredIds;
  int? page;
  int? pageSize;

  factory Next.fromJson(Map<String, dynamic> json) => _$NextFromJson(json);
  Map<String, dynamic> toJson() => _$NextToJson(this);
}

@JsonSerializable()
class References {
  References();

  factory References.fromJson(Map<String, dynamic> json) =>
      _$ReferencesFromJson(json);
  Map<String, dynamic> toJson() => _$ReferencesToJson(this);
}

@JsonSerializable()
class Value {
  Value({
    this.id,
    this.name,
    this.slug,
    this.tags,
    this.creatorId,
    this.description,
    this.shortDescription,
    this.image,
    this.metadata,
    this.virtuals,
    this.logo,
    this.twitterUsername,
    this.facebookPageName,
    this.publicEmail,
    this.collectionMastheadId,
    this.domain,
    this.favicon,
    this.colorPalette,
    this.navItems,
    this.colorBehavior,
    this.acceleratedMobilePagesState,
    this.googleAnalyticsId,
    this.ampLogo,
    this.header,
    this.subscriberCount,
    this.tagline,
    this.polarisCoverImage,
    this.ptsQualifiedAt,
    this.type,
  });

  String? id;
  String? name;
  String? slug;
  List<String>? tags;
  String? creatorId;
  String? description;
  String? shortDescription;
  AmpLogo? image;
  Metadata? metadata;
  Virtuals? virtuals;
  AmpLogo? logo;
  String? twitterUsername;
  String? facebookPageName;
  String? publicEmail;
  String? collectionMastheadId;
  String? domain;
  AmpLogo? favicon;
  ColorPalette? colorPalette;
  List<NavItem>? navItems;
  int? colorBehavior;
  int? acceleratedMobilePagesState;
  String? googleAnalyticsId;
  AmpLogo? ampLogo;
  Header? header;
  int? subscriberCount;
  String? tagline;
  AmpLogo? polarisCoverImage;
  int? ptsQualifiedAt;
  String? type;

  factory Value.fromJson(Map<String, dynamic> json) => _$ValueFromJson(json);
  Map<String, dynamic> toJson() => _$ValueToJson(this);
}

@JsonSerializable()
class AmpLogo {
  AmpLogo({
    this.imageId,
    this.filter,
    this.backgroundSize,
    this.originalWidth,
    this.originalHeight,
    this.strategy,
    this.height,
    this.width,
  });

  String? imageId;
  String? filter;
  String? backgroundSize;
  int? originalWidth;
  int? originalHeight;
  Strategy? strategy;
  int? height;
  int? width;

  factory AmpLogo.fromJson(Map<String, dynamic> json) =>
      _$AmpLogoFromJson(json);
  Map<String, dynamic> toJson() => _$AmpLogoToJson(this);
}

enum Strategy { resample }

@JsonSerializable()
class ColorPalette {
  ColorPalette({
    this.defaultBackgroundSpectrum,
    this.highlightSpectrum,
    this.darkBackgroundSpectrum,
  });

  Spectrum? defaultBackgroundSpectrum;
  Spectrum? highlightSpectrum;
  Spectrum? darkBackgroundSpectrum;

  factory ColorPalette.fromJson(Map<String, dynamic> json) =>
      _$ColorPaletteFromJson(json);
  Map<String, dynamic> toJson() => _$ColorPaletteToJson(this);
}

@JsonSerializable()
class Spectrum {
  Spectrum({
    this.colorPoints,
    this.backgroundColor,
  });

  List<ColorPoint>? colorPoints;
  String? backgroundColor;

  factory Spectrum.fromJson(Map<String, dynamic> json) =>
      _$SpectrumFromJson(json);
  Map<String, dynamic> toJson() => _$SpectrumToJson(this);
}

@JsonSerializable()
class ColorPoint {
  ColorPoint({
    this.color,
    this.point,
  });

  String? color;
  double? point;

  factory ColorPoint.fromJson(Map<String, dynamic> json) =>
      _$ColorPointFromJson(json);
  Map<String, dynamic> toJson() => _$ColorPointToJson(this);
}

@JsonSerializable()
class Header {
  Header({
    this.title,
    this.description,
    this.backgroundImage,
    this.logoImage,
    this.alignment,
    this.layout,
  });

  String? title;
  String? description;
  BackgroundImage? backgroundImage;
  LogoImage? logoImage;
  int? alignment;
  int? layout;

  factory Header.fromJson(Map<String, dynamic> json) => _$HeaderFromJson(json);
  Map<String, dynamic> toJson() => _$HeaderToJson(this);
}

@JsonSerializable()
class BackgroundImage {
  BackgroundImage({
    this.id,
    this.originalWidth,
    this.originalHeight,
    this.focusPercentX,
    this.focusPercentY,
  });

  String? id;
  int? originalWidth;
  int? originalHeight;
  double? focusPercentX;
  double? focusPercentY;

  factory BackgroundImage.fromJson(Map<String, dynamic> json) =>
      _$BackgroundImageFromJson(json);
  Map<String, dynamic> toJson() => _$BackgroundImageToJson(this);
}

@JsonSerializable()
class LogoImage {
  LogoImage({
    this.id,
    this.originalWidth,
    this.originalHeight,
    this.alt,
  });

  String? id;
  int? originalWidth;
  int? originalHeight;
  String? alt;

  factory LogoImage.fromJson(Map<String, dynamic> json) =>
      _$LogoImageFromJson(json);
  Map<String, dynamic> toJson() => _$LogoImageToJson(this);
}

@JsonSerializable()
class Metadata {
  Metadata({
    this.followerCount,
    this.activeAt,
  });

  int? followerCount;
  int? activeAt;

  factory Metadata.fromJson(Map<String, dynamic> json) =>
      _$MetadataFromJson(json);
  Map<String, dynamic> toJson() => _$MetadataToJson(this);
}

@JsonSerializable()
class NavItem {
  NavItem({
    this.type,
    this.title,
    this.postId,
    this.url,
    this.source,
  });

  int? type;
  String? title;
  String? postId;
  String? url;
  String? source;

  factory NavItem.fromJson(Map<String, dynamic> json) =>
      _$NavItemFromJson(json);
  Map<String, dynamic> toJson() => _$NavItemToJson(this);
}

@JsonSerializable()
class Virtuals {
  Virtuals({
    this.permissions,
    this.isSubscribed,
    this.isEnrolledInHightower,
    this.isEligibleForHightower,
    this.isSubscribedToCollectionEmails,
    this.isMuted,
    this.canToggleEmail,
    this.isWriter,
  });

  Map<String, bool>? permissions;
  bool? isSubscribed;
  bool? isEnrolledInHightower;
  bool? isEligibleForHightower;
  bool? isSubscribedToCollectionEmails;
  bool? isMuted;
  bool? canToggleEmail;
  bool? isWriter;

  factory Virtuals.fromJson(Map<String, dynamic> json) =>
      _$VirtualsFromJson(json);
  Map<String, dynamic> toJson() => _$VirtualsToJson(this);
}
