import 'package:json_annotation/json_annotation.dart';

part 'tags_search_dto.g.dart';

@JsonSerializable()
class TagsSearchDto {
  TagsSearchDto({
    this.success,
    this.payload,
    this.v,
    this.b,
  });

  List<Tag> get tags => payload!.tags!;

  bool? success;
  Payload? payload;
  int? v;
  String? b;

  factory TagsSearchDto.fromJson(Map<String, dynamic> json) =>
      _$TagsSearchDtoFromJson(json);
  Map<String, dynamic> toJson() => _$TagsSearchDtoToJson(this);
}

@JsonSerializable()
class Payload {
  Payload({
    this.tags,
    this.references,
  });

  @JsonKey(name: "value")
  List<Tag>? tags;
  References? references;

  factory Payload.fromJson(Map<String, dynamic> json) =>
      _$PayloadFromJson(json);
  Map<String, dynamic> toJson() => _$PayloadToJson(this);
}

@JsonSerializable()
class References {
  References();

  factory References.fromJson(Map<String, dynamic> json) =>
      _$ReferencesFromJson(json);
  Map<String, dynamic> toJson() => _$ReferencesToJson(this);
}

@JsonSerializable()
class Tag {
  Tag({
    this.slug,
    this.name,
    this.postCount,
    this.metadata,
    this.type,
  });

  String? slug;
  String? name;
  int? postCount;
  Metadata? metadata;
  String? type;

  factory Tag.fromJson(Map<String, dynamic> json) => _$TagFromJson(json);
  Map<String, dynamic> toJson() => _$TagToJson(this);
}

@JsonSerializable()
class Metadata {
  Metadata({
    this.postCount,
    this.coverImage,
  });

  int? postCount;
  CoverImage? coverImage;

  factory Metadata.fromJson(Map<String, dynamic> json) =>
      _$MetadataFromJson(json);
  Map<String, dynamic> toJson() => _$MetadataToJson(this);
}

@JsonSerializable()
class CoverImage {
  CoverImage({
    this.id,
    this.originalWidth,
    this.originalHeight,
    this.isFeatured,
  });

  String? id;
  int? originalWidth;
  int? originalHeight;
  bool? isFeatured;

  factory CoverImage.fromJson(Map<String, dynamic> json) =>
      _$CoverImageFromJson(json);
  Map<String, dynamic> toJson() => _$CoverImageToJson(this);
}
