import 'package:json_annotation/json_annotation.dart';

part 'users_search_dto.g.dart';

@JsonSerializable()
class UsersSearchDto {
  UsersSearchDto({
    this.b,
    this.payload,
    this.success,
    this.v,
  });

  String? b;
  Payload? payload;
  bool? success;
  int? v;

  factory UsersSearchDto.fromJson(Map<String, dynamic> json) =>
      _$UsersSearchDtoFromJson(json);
  Map<String, dynamic> toJson() => _$UsersSearchDtoToJson(this);
}

@JsonSerializable()
class Payload {
  Payload({
    this.paging,
    this.references,
    this.total,
    this.users,
  });

  Paging? paging;
  References? references;
  int? total;
  @JsonKey(name: "value")
  List<User>? users;

  factory Payload.fromJson(Map<String, dynamic> json) =>
      _$PayloadFromJson(json);
  Map<String, dynamic> toJson() => _$PayloadToJson(this);
}

@JsonSerializable()
class Paging {
  Paging({
    this.method,
    this.next,
    this.path,
  });

  String? method;
  Next? next;
  String? path;

  factory Paging.fromJson(Map<String, dynamic> json) => _$PagingFromJson(json);
  Map<String, dynamic> toJson() => _$PagingToJson(this);
}

@JsonSerializable()
class Next {
  Next({
    this.ignoredIds,
    this.page,
    this.pageSize,
  });

  List<String>? ignoredIds;
  int? page;
  int? pageSize;

  factory Next.fromJson(Map<String, dynamic> json) => _$NextFromJson(json);
  Map<String, dynamic> toJson() => _$NextToJson(this);
}

@JsonSerializable()
class References {
  References({
    this.social,
  });

  Map<String, Social>? social;
  factory References.fromJson(Map<String, dynamic> json) =>
      _$ReferencesFromJson(json);
  Map<String, dynamic> toJson() => _$ReferencesToJson(this);
}

@JsonSerializable()
class Social {
  Social({
    this.targetUserId,
    this.type,
    this.userId,
  });

  String? targetUserId;
  SocialType? type;
  String? userId;

  Map<String, Social>? social;
  factory Social.fromJson(Map<String, dynamic> json) => _$SocialFromJson(json);
  Map<String, dynamic> toJson() => _$SocialToJson(this);
}

enum SocialType {
  @JsonValue("SOCIAL")
  social,
}

@JsonSerializable()
class User {
  User({
    this.allowNotes,
    this.backgroundImageId,
    this.bio,
    this.createdAt,
    this.firstOpenedAndroidApp,
    this.firstOpenedIosApp,
    this.hasCompletedProfile,
    this.hasSeenIcelandOnboarding,
    this.imageId,
    this.isCreatorPartnerProgramEnrolled,
    this.isMembershipTrialEligible,
    this.isSuspended,
    this.isWriterProgramEnrolled,
    this.mediumMemberAt,
    this.name,
    this.optInToIceland,
    this.postSubscribeMembershipUpsellShownAt,
    this.replyToEmailBannerShownCount,
    this.subdomainCreatedAt,
    this.twitterScreenName,
    this.type,
    this.userDismissableFlags,
    this.userFlags,
    this.userId,
    this.username,
  });

  int? allowNotes;
  String? backgroundImageId;
  String? bio;
  int? createdAt;
  int? firstOpenedAndroidApp;
  int? firstOpenedIosApp;
  bool? hasCompletedProfile;
  bool? hasSeenIcelandOnboarding;
  String? imageId;
  bool? isCreatorPartnerProgramEnrolled;
  bool? isMembershipTrialEligible;
  bool? isSuspended;
  bool? isWriterProgramEnrolled;
  int? mediumMemberAt;
  String? name;
  bool? optInToIceland;
  int? postSubscribeMembershipUpsellShownAt;
  int? replyToEmailBannerShownCount;
  int? subdomainCreatedAt;
  String? twitterScreenName;
  ValueType? type;
  List<int>? userDismissableFlags;
  List<int>? userFlags;
  String? userId;
  String? username;

  factory User.fromJson(Map<String, dynamic> json) => _$UserFromJson(json);
  Map<String, dynamic> toJson() => _$UserToJson(this);
}

enum ValueType {
  @JsonValue("User")
  user,
}
