import 'package:medium_search/medium_search.dart';
import 'package:test/test.dart';

void main() {
  group('A group of tests', () {
    final medium = Medium();

    test('Search for tags', () async {
      await medium.getTags("Hello").then((tags) {
        for (var tag in tags) {
          print("The tag `${tag.name}` has ${tag.postCount} posts.");
        }
      });
    });

    test("Search for Users", () async {
      var page = await medium.getUsers("social", count: 10);

      print("====> Page 1:");
      for (var user in page.users) {
        print("${user.name} => ${user.bio}");
      }

      for (int i = 0; i < 2; i++) {
        page = await page.nextPage;

        print("====> Page ${page.number}");

        for (var user in page.users) {
          print("${user.name} => ${user.bio}");
        }
      }
    });

    test("Search for Publications", () async {
      var page = await medium.getPublications("hello", count: 10);

      print("====> Page 1:");
      for (var public in page.users) {
        print("${public.name} => ${public.description}");
      }

      for (int i = 0; i < 2; i++) {
        page = await page.nextPage;

        print("====> Page ${page.number}");

        for (var public in page.users) {
          print("${public.name} => ${public.description}");
        }
      }
    });

    test("Search for Posts", () async {
      var page = await medium.getPosts("hello", count: 10);

      print("====> Page 1:");
      for (var post in page.posts) {
        print("${post.title} => ${post.id}");
      }

      for (int i = 0; i < 2; i++) {
        page = await page.nextPage;

        print("====> Page ${page.number}");

        for (var post in page.posts) {
          print("${post.title} => ${post.id}");
        }
      }
    });
  });
}
